﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Interop.Excel;
using _Excel = Microsoft.Office.Interop.Excel;

namespace ConsoleApp1
{
    class Program
    {
        static string mypath = "";
        static _Application excel = new _Excel.Application();
        static Workbook wb;
        static Worksheet ws;

        static void Main(string[] args)
        {
            Excel("C:\\Users\\SorinLiviu\\Desktop\\CRC16_Calculator\\ConsoleApp1\\test.xlsx", 1);
            int i = 1;
            string mystring = "";
            int intValue;
            string hexValue;
            byte[] bytes;

            Console.WriteLine("CRC 16-bit Signatures are Generated. Please wait a few seconds... ");
            while (ws.Cells[i, 1].Value2 != null)
            {
                mystring = ((int)(ws.Cells[i, 1].Value2)).ToString() + '.' + ((int)(ws.Cells[i, 2].Value2)).ToString() + '.' + ((int)(ws.Cells[i, 3].Value2)).ToString() + '.' + ((int)(ws.Cells[i, 4].Value2)).ToString();
                bytes = Encoding.ASCII.GetBytes(mystring);
               // Console.WriteLine(mystring);
                intValue = crc16(bytes, mystring.Length);
                hexValue = "0X" + intValue.ToString("X");
                ws.Cells[i, 5] = hexValue;
                //Console.Read();
                i++;
            }

            object misValue = System.Reflection.Missing.Value;
            wb.SaveAs("C:\\Users\\SorinLiviu\\Desktop\\CRC16_Calculator\\ConsoleApp1\\test_output.xlsx");
            wb.Close(true, misValue, misValue);
            excel.Quit();

            // Call the garbage collector to collect and wait for finalizers to finish.
            GC.Collect();
            GC.WaitForPendingFinalizers();

            Console.WriteLine("Done. Check your test_output.xlsx to see the generated signatures in column E.");
            Console.Read();
        }

        static void Excel(string path, int sheet)
        {
            mypath = path;
            wb = excel.Workbooks.Open(mypath);
            ws = wb.Worksheets[sheet];
        }

        static int crc16(byte[] data_p, int length){
           int x;
           int crc = 0xFFFF;
           int i = 0;
           while (length > 0){
                length -= 1;
                x = (((crc >> 8)&(0x0000ffff)) ^ data_p[i] ) & (0x0000ffff);
                x = (x ^ x>>4) & (0x0000ffff) ;
                crc = ((crc << 8) ^ ((ushort)(x << 12)) ^ ((ushort)(x <<5)) ^ ((ushort)x)) & (0x0000ffff) ;
                i += 1;
           }
        return crc;
      }

    }
}
